//=============================================================================
//                                                              PowerSwing.mq4
//                                               Copyright  2009, Xavier Chaparro
//
//=============================================================================
#property copyright "Copyright  2009, Xavier Chaparro"


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Yellow
#property indicator_color3 Lime
#property indicator_color4 Yellow
#property indicator_color5 Lime
#property indicator_color6 Yellow

// buffers
double BuyEntryBuf[];
double SellEntryBuf[];
double BuyExitBuf[];
double SellExitBuf[];
double AddBuyBuf[];
double AddSellBuf[];


extern bool			IsEA_Calling		= false;
extern bool			UseAlert			= false;
extern color		LegendColor			= Yellow;
extern bool			UseVolExpanding		= true;
extern bool			UseiTrend		= false;
extern double	   UnlessVolWidthGT		= 20.0;
extern int			LegendCorner		= 3;
extern string		Comment9			= "Corner: 0=UL , 1=UR , 2=LL , 3=LR";


// Globals --------------------------------------

// Indicator values
double	HA_HiLo_2, HA_LoHi_2, HA_Open_1, HA_Close_1, HA_Close_0, HA_Open_0, HA_HiLo_0, HA_LoHi_0;
double	HA_DM0_2, HA_DM1_2, HA_Open_2, HA_Close_2;
double	TDI0_1, BlueH_1, Yellow_1,  Yellow_0, BlueL_1, Green_1, Green_0;
double	Red_0, Red_1, Red_2, BlueH_0, BlueL_0, rf;
double	MA_Hi_0, MA_Lo_0;
double	MA_Hi_1, MA_Lo_1;
double	MA_Hi_2, MA_Lo_2;
double Trendline01,Trendline11,Trendline02,Trendline12,Trendline03,Trendline04;
double HMABlue0,HMABlue1,HMAYellow0,HMAYellow1,HMARed0,HMARed1;
double OffBlue0,OffBlue1,OffRed0,OffRed1;
double iGreen0,iGreen1,iRed0,iRed1;

// Other

int			 PAChannel;
string		ExitReason;
datetime 	PrevTime;
int gi_748;
double gd_760;



//=============================================================================
// Custom indicator initialization & deinitialization functions
//=============================================================================
int init()
{
	if (Digits < 4) {
      gd_760 = 0.01;
      gi_748 = 2;
   } else {
      gd_760 = 0.0001;
      gi_748 = 4;
   }

	
	// Entry arrow
	SetIndexStyle(0,DRAW_ARROW);
	SetIndexArrow(0,233);
	SetIndexBuffer(0,BuyEntryBuf);
	SetIndexEmptyValue(0,0.0);
	SetIndexStyle(1,DRAW_ARROW);
	SetIndexArrow(1,234);
	SetIndexBuffer(1,SellEntryBuf);
	SetIndexEmptyValue(1,0.0);
	
	// Exit arrow
	SetIndexStyle(2,DRAW_ARROW);
	SetIndexArrow(2,251);
	SetIndexBuffer(2,BuyExitBuf);
	SetIndexEmptyValue(2,0.0);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexArrow(3,251);
	SetIndexBuffer(3,SellExitBuf);
	SetIndexEmptyValue(3,0.0);
	
	// Possible add-to-trade arrow
	SetIndexStyle(4,DRAW_ARROW);
	SetIndexArrow(4,241);
	SetIndexBuffer(4,AddBuyBuf);
	SetIndexEmptyValue(4,0.0);
	SetIndexStyle(5,DRAW_ARROW);
	SetIndexArrow(5,242);
	SetIndexBuffer(5,AddSellBuf);
	SetIndexEmptyValue(5,0.0);

	int y1 = 50, y2 = 40, y3 = 30, y4 = 20, y5 = 10;
	if (!IsEA_Calling)
	{
		if (LegendCorner == 0 || LegendCorner == 1)
		{
			y1 = 10; y2 = 20; y3 = 30; y4 = 40; y5 = 50;
		}
	

	}	
	return(0);
}


int deinit()
{
	if (!IsEA_Calling)
	{
		string name;
		for (int i = Bars; i >= 0; i--)
		{
			name = "PowerSwingBuyopen" + DoubleToStr(i ,0);
			ObjectDelete(name);
			name = "PowerSwingSellopen" + DoubleToStr(i ,0);
			ObjectDelete(name);
			name = "PowerSwingBuyClose" + DoubleToStr(i ,0);
			ObjectDelete(name);
			name = "PowerSwingSellClose" + DoubleToStr(i ,0);
			ObjectDelete(name);
		}
		ObjectDelete("TotalPips");
		ObjectDelete("Legend1");
		ObjectDelete("Legend2");
		ObjectDelete("Legend3");
		ObjectDelete("Legend4");
		ObjectDelete("Legend5");
	}
	return(0);
}


//=============================================================================
//| Custom indicator iteration function                              |
//=============================================================================
int start()
{
	static int		RunningTotal = 0;
	static bool 	InBuy = false;
	static bool 	InSell = false;
	static double	OpenPriceB = 0;
	static double	OpenPriceS = 0;

	int 	i, limit;
	double	a, b, c, d, e, f, g;
	int		pipsMade;
	color	clr;
	string	name, text;
	double	upperPos, lowerPos, upperTextPos, lowerTextPos,upperTextPos2,lowerTextPos2;
	double	spread;
	
	// Run only once per candle
	if (PrevTime == Time[0])
		return;
	PrevTime = Time[0];

	// Get already counted bars    
	int counted_bars = IndicatorCounted();

	// Check for possible errors
	if (counted_bars < 0) 
		return (-1);
		
	limit = Bars - counted_bars - 1;
	
	// Don't do ALL the way back to start, 
	// because we reference earlier candles
	if (limit > 100)
		limit -= 5;
	
	int sp = 3;
	switch (Period())
	{
		case PERIOD_M5:		sp = 7; 	break;
		case PERIOD_M15:	sp = 12; 	break;
		case PERIOD_M30:	sp = 10; 	break;
		case PERIOD_H1:		sp = 15; 	break;
		case PERIOD_H4:		sp = 35; 	break;
		case PERIOD_D1:		sp = 90; 	break;
		case PERIOD_W1:		sp = 120; 	break;
		case PERIOD_MN1:	sp = 170; 	break;
	}
	
	// Main loop
	for (i = limit; i >= 0; i--) 
	{
		double nowprice;
		AcquireIndicatorValues(i);
		PAChannel = BlueH_0 - BlueL_0;
 //      Print("price ",Bid," HMABlue0= ",HMABlue0 ," HMARed0= ",HMARed0," GetTrendline_ExitDir() ",GetTrendline_ExitDir() );
		// Check for open signals ---------------------------------------------
		
		
		// Calculate where to put arrows (and labels)
		upperPos = MathMax(High[i], MathMax(HA_HiLo_2, HA_LoHi_2)) + ((sp)*gd_760);
		upperTextPos = upperPos + ((sp)*gd_760);
		upperTextPos2 = upperPos + ((sp+8)*gd_760);
		lowerPos = MathMin(Low[i], MathMin(HA_HiLo_2, HA_LoHi_2)) - ((sp)*gd_760);
		lowerTextPos = lowerPos - ((sp)*gd_760);
		lowerTextPos2 = lowerPos - ((sp+8)*gd_760);
		spread = Ask - Bid;

      if (i>0) nowprice = Open[i];
      else nowprice = Bid;
		
		// If all in Long position, signal to BUY at this candle's open
		if (!InBuy && 
			(/*GetHMA_EntryDir() == OP_BUY || */GetOfftrend_EntryDir()==OP_BUY) && (!UseVolExpanding || VolBandsExpanding())
			&& (!UseiTrend ||Getitrend_EntryDir()==OP_BUY)  ) 
		{
			BuyEntryBuf[i] = lowerPos;
			InBuy = true;
			OpenPriceB = nowprice + spread;
			DoAlert(i, "PowerSwing: "+Symbol()+"  New Buy Signal " + Bid);
		
		   if (!IsEA_Calling)
			{
				name = "PowerSwingBuyopen" + DoubleToStr(i ,0);
				text = DoubleToStr(OpenPriceB,gi_748);
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], lowerTextPos2);
				ObjectSetText(name, text, 8, "Times New Roman", Aqua);
				
			}
		}
		
		
		
		// If all in Short position, signal to SELL at this candle's open
		if (!InSell  && 
			(/*GetHMA_EntryDir() == OP_SELL || */GetOfftrend_EntryDir()==OP_SELL) && (!UseVolExpanding || VolBandsExpanding()) 
			&& (!UseiTrend ||Getitrend_EntryDir()==OP_SELL))
		{
			SellEntryBuf[i] = upperPos;
			InSell = true;
			OpenPriceS = nowprice - spread;
			DoAlert(i, "PowerSwing: "+Symbol()+" New Sell Signal " + Bid);
		   
		   if (!IsEA_Calling)
			{
				name = "PowerSwingSellopen" + DoubleToStr(i ,0);
				text = DoubleToStr(OpenPriceS,gi_748);
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], upperTextPos2);
				ObjectSetText(name, text, 8, "Times New Roman", Aqua);
				
			}
		}

		
		

		// Check for close signals --------------------------------------------
			
		// If all in Short position, signal to EXIT LONG at this candle's open
		if (InBuy &&  (GetTrendline_ExitDir() == OP_SELL /*|| GetHMA_EntryDir() == OP_SELL */ ))
		{
			BuyExitBuf[i] = upperPos;
			InBuy = false;
			pipsMade = (nowprice - OpenPriceB-spread) / gd_760;
			RunningTotal += pipsMade;

			// Create label for pips made for this trade
			clr = Red;
			if (pipsMade >= 0)
				clr = Lime;

			if (!IsEA_Calling)
			{
				name = "PowerSwingBuyClose" + DoubleToStr(i ,0);
				text = DoubleToStr(nowprice,gi_748)+" "+DoubleToStr(pipsMade ,0) + " Pips ";
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], upperTextPos);
				ObjectSetText(name, text, 8, "Times New Roman", clr);
				DoAlert(i, "PowerSwing: "+Symbol()+" Exit Buy Signal " + Bid);
			}
		}
				
		// If all in Long position, signal to EXIT SHORT position at this candle's open
		if (InSell &&  (GetTrendline_ExitDir() == OP_BUY/* || GetHMA_EntryDir() == OP_BUY*/  ) )
		{
			SellExitBuf[i] = lowerPos;
			InSell = false;
			pipsMade = (OpenPriceS - nowprice-spread) / gd_760;
			RunningTotal += pipsMade;

			// Create label for pips made for this trade
			clr = Red;
			if (pipsMade >= 0)
				clr = Lime;

			if (!IsEA_Calling)
			{
				name = "PowerSwingSellClose" + DoubleToStr(i ,0);
				text = DoubleToStr(nowprice+spread,gi_748)+" "+DoubleToStr(pipsMade ,0) + " Pips ";
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], lowerTextPos);
				ObjectSetText(name, text, 8, "Times New Roman", clr);
				DoAlert(i, "PowerSwing: "+Symbol()+" Exit Sell Signal" + Bid);
			}
		}
//		Print("i == " + i + "        InBuy == " + InBuy + "        InSell == " + InSell);
	}

	// On zero (most recent) candle, put up the total (only once)
	if (!IsEA_Calling)
	{
	  color LColor = Red;
	   if (PAChannel > UnlessVolWidthGT) LColor = Lime;
//    ObjectDelete("TotalPips");
//		text = DoubleToStr(RunningTotal ,0) + " pips: " + Bars + " Bars" + " PAC "+PAChannel;
//		ObjectCreate("TotalPips", OBJ_TEXT, 0, Time[0], upperTextPos + sp*gd_760);
//		ObjectSetText("TotalPips", text, 10, "Times New Roman", Yellow);

	   
		text = " PAC "+PAChannel;
		ObjectCreate("Legend1", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend1", text, 10, "Arial Bold", LColor);
		ObjectSet("Legend1", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend1", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend1", OBJPROP_YDISTANCE, 10);
		
		text = DoubleToStr(RunningTotal ,0) + " pips: " + Bars + " Bars";
		ObjectCreate("Legend2", OBJ_LABEL, 0, 0, 0);
		ObjectSetText("Legend2", text, 8, "Arial Bold", LegendColor);
		ObjectSet("Legend2", OBJPROP_CORNER, LegendCorner);
		ObjectSet("Legend2", OBJPROP_XDISTANCE, 10);
		ObjectSet("Legend2", OBJPROP_YDISTANCE, 30);

	}

	return(0);
}


void DoAlert(int i, string str)
{
	if (UseAlert )
		Alert(str);
}


void AcquireIndicatorValues(int i) 
{
	// Get Haiken Ashi values (now closed candle)
	HA_Open_0  = iCustom(NULL, 0, "HeikenAshi_DM",   2, i); // Open
	HA_Close_0 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i); // Close
	HA_HiLo_0  = iCustom(NULL, 0, "HeikenAshi_DM",   0, i); // Low  (if long, else High)
	HA_LoHi_0  = iCustom(NULL, 0, "HeikenAshi_DM",   1, i); // High (if long, else Low)
	
	// Get Haiken Ashi values (last closed candle)
	HA_HiLo_2  = iCustom(NULL, 0, "HeikenAshi_DM",   0, i+1); // Low  (if long, else High)
	HA_LoHi_2  = iCustom(NULL, 0, "HeikenAshi_DM",   1, i+1); // High (if long, else Low)
	HA_Open_1  = iCustom(NULL, 0, "HeikenAshi_DM",   2, i+1); // Open
	HA_Close_1 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i+1); // Close
	
	// Get Haiken Ashi values (one prior to last closed candle)
	HA_Open_2 = iCustom(NULL, 0, "HeikenAshi_DM",   2, i+2); // Open
	HA_Close_2 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i+2); // Close
	
	// Get Traders Dynamic Index values
	BlueH_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, i+1);	// Blue   (H. Vol Band)
	Yellow_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, i+1);	// Yellow (Market Base)
	Yellow_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, i);	// Yellow (Market Base)
	BlueL_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, i+1);	// Blue   (L. Vol Band)
	Green_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, i+1);	// Green  (RSI Price)
	Green_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, i);	// Green  (RSI Price)
	Red_1 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i+1);	// Red    (Trade Signal)
	Red_0 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i);		// Red    (Current Candle)
	Red_2 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, i+2);	// Red    (Prev Prev Candle)
	BlueH_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, i);		// Blue   (Current Candle)
	BlueL_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, i);		// Blue   (Current Candle)
	
	// Get Smoothed Moving Average values
	MA_Hi_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i);
	MA_Lo_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i);
	MA_Hi_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+1);
	MA_Lo_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i+1);
	MA_Hi_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+2);
	MA_Lo_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i+2);

   
   
       // Get Trendline
   Trendline01 = iCustom(NULL, 0, "trendline", 0, i);
   Trendline11 = iCustom(NULL, 0, "trendline", 0, i+1);
   Trendline02 = iCustom(NULL, 0, "trendline", 1, i);
   Trendline12 = iCustom(NULL, 0, "trendline", 1, i+1);
   Trendline03 = iCustom(NULL, 0, "trendline", 2, i); 
   Trendline04 = iCustom(NULL, 0, "trendline", 3, i);

	 // Get offtrend
   OffBlue0 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,0, i);
   OffBlue1 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,0, i+1);
   OffRed0 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,1, i);
   OffRed1 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,1, i+1);
	
     // Get HMA
   HMABlue0 = iCustom(NULL, 0, "HMA Modified", 0, i);
   HMABlue1 = iCustom(NULL, 0, "HMA Modified", 0, i+1);
   HMAYellow0 = iCustom(NULL, 0, "HMA Modified", 1, i);
   HMAYellow0 = iCustom(NULL, 0, "HMA Modified", 1, i+1);
   HMARed0 = iCustom(NULL, 0, "HMA Modified", 2, i);
   HMARed1 = iCustom(NULL, 0, "HMA Modified", 2, i+1);
   
        // Get itrend
   iGreen0 = iCustom(NULL, 0, "i_Trend", 0, i);
   iGreen1 = iCustom(NULL, 0, "i_Trend", 0, i+1);
   iRed0 = iCustom(NULL, 0, "i_Trend", 1, i);
   iRed0 = iCustom(NULL, 0, "i_Trend", 1, i+1);
}






int GetOfftrend_EntryDir()
{

	if (//(OffBlue0 > OffRed0 ) && 
	   ( HMABlue0 > OffRed0) && ( HMABlue1 < OffRed1)&& HMABlue0  !=  2147483647 && HMABlue1  !=  2147483647  
	  )
		
		return(OP_BUY);
	else 
	if (//(OffBlue0 < OffRed0 )&&   
	   ( HMARed0 < OffRed0) && ( HMARed1 > OffRed1) && HMARed0  !=  2147483647 && HMARed1  !=  2147483647
	   ) 
	   
		return(OP_SELL);
	return(-1);
}

int Getitrend_EntryDir()
{

	if ((iGreen0 > iRed0 )  
	   
	  )
		
		return(OP_BUY);
	else 
	if ((iGreen0 < iRed0 )
	   
	   ) 
	   
		return(OP_SELL);
	return(-1);
}

int GetHMA_EntryDir()
{

	if (//(Trendline01 > OffRed0 ) && 
	  //( Trendline11 < OffRed1) || 
	   (HMABlue0 > Trendline02 ) && ( HMABlue1 < Trendline12) 
	   && HMARed0  ==  2147483647) 
		
		return(OP_BUY);
	else 
	if (//(Trendline01 < OffRed0 ) && 
	   //( Trendline11 > OffRed1) || 
	   (HMARed0 < Trendline02 ) && ( HMARed1 > Trendline12) 
	   && HMABlue0  ==  2147483647) 
		return(OP_SELL);
	return(-1);
}

int GetTDI_EntryDir()
{
	if (Green_0 >= Yellow_0 && Green_0 > Green_1) 
		
		return(OP_BUY);
	else 
	if (Green_0 <= Yellow_0 && Green_0 < Green_1)
		return(OP_SELL);
	return(-1);
}



int GetTrendline_ExitDir()
{
	// Check for exiting Buy position
	if //(HMARed0 < Trendline01)
	    (HMABlue0  ==  2147483647  )
	{
		ExitReason = "Trend";
		return(OP_SELL);
	}
	else 
	// Check for exiting sell position
	if //(HMABlue0 > Trendline01) 
	    (HMARed0  ==  2147483647 )
	{
		ExitReason = "Trend";
		return(OP_BUY);
	}
	return(-1);
}

int GetOfftrend_ExitDir()
{

	//Exit Sell
	if ( HMABlue0 > OffRed0 &&  HMABlue1 < OffRed1&& HMABlue0  !=  2147483647 && HMABlue1  !=  2147483647)
	  
		
		return(OP_BUY);
	else 
	//Exit Buy
	if  ( HMARed0 < OffRed0 &&  HMARed1 > OffRed1  && HMARed0  !=  2147483647 && HMARed1  !=  2147483647)
	   
	   
		return(OP_SELL);
	return(-1);
}



bool VolBandsExpanding()
{
	if (//(BlueH_0 - BlueL_0 > BlueH_1 - BlueL_1) && 
	((BlueH_0 - BlueL_0) > UnlessVolWidthGT))
		return(true);
	return(false);
}








